#include <string.h>
#include <stdlib.h>
#include <assert.h>

#include "config.h"
#include "entry.hpp"

CEntry::CEntry(FILE *fpFile, void *pvTarget, size_t iBytes, PGetEntry pvfGetEntry)
{
	memset(pvTarget, 0, iBytes);
	
	iErrorCode = NO_ERROR;
	
	char *pszEntry = new char[MAX_ENTRY];
	if (NULL == pszEntry) {
		iErrorCode = MEMORY_ERROR;
		return;
	}
	if (!fgets(pszEntry, MAX_ENTRY, fpFile)) {
		iErrorCode = EOF_ERROR;
		delete pszEntry;
		return;
	}
	char *pszNewLine;
	if ((pszNewLine = strrchr(pszEntry, '\n')))
		*pszNewLine = '\0';
// Get some cleared memory for the shadow structure
	if (false == (*pvfGetEntry)(pszEntry, pvTarget))
		iErrorCode = PARSE_ERROR;

	delete pszEntry;
}

CEntry::CEntry()
{
	iErrorCode = NO_ERROR;
}

long CEntry::ToLong(char *pszEntry, long lDefault, bool *fgError)
{
	if ((NULL == pszEntry) || '\0' == pszEntry[0])
		return lDefault;
	char *pszInvalid;
	long lResult = strtol(pszEntry, &pszInvalid, 10);
	if ('\0' == *pszInvalid)				// We want the whole string to be valid
		return lResult;		
	*fgError = true;
	return lDefault;							// Field contains invalud characters	
}
